# -*- coding: utf-8 -*-
import logging

#debug = True
debug = False

# If this settings is on, then when doing changes to filter form,
# you should erase all sessions, because old filter forms are still
# in session.
caching_filter_form_javascript = True

www_dir = '/usr/share/fred-webadmin/www/'
locale_dir = '/usr/share/pyshared/fred_webadmin/locale/'
sessions_dir = '/var/lib/fred-webadmin/sessions/'
log_dir = '/var/log/fred-webadmin/'
log_level = logging.ERROR

# logging_actions_enabled: If false no user actions are logged to logd.
# viewing_actions_enabled: If false, users cannot display log screen in
#                          Daphne.
# force_critical_logging: If False, any logger-related failure will silently
#                         be ignored. If True, failures will shoot Daphne
#                         down.
audit_log = {
    'logging_actions_enabled': True,
    'viewing_actions_enabled': True,
    'force_critical_logging': True,
}

# enable_checking: If false, no security policy is enforced (there is
#                  no authorization).
# backend: Select from 'csv', 'nicauth' to specify the backend for permission
#          data.
# csv_file: Used only when 'csv' backend is selected. Speicfy the path to the
#           file with permissions.
#           File row format: username,action1.object1,action2.object2...
#           e.g.: testuser,read.domain,write.registrar,read.registrar...
permissions = {
    'enable_checking': False,
    'backend': 'csv',  # , 'nicauth'
    'csv_file': '/usr/share/perms.csv',
}

# '/usr/share/idl/fred/ccReg.idl'
idl = '/usr/share/idl/fred/ccReg.idl'
# (label, nshost, nscontext),
iors = (('Fred', 'localhost:2809', 'fred'),)

table_page_size = 45
table_timeout = 10000

# default max row limit for tables
table_max_row_limit = 1000
# specific max row to override limit for particular objects:
table_max_row_limit_per_obj = {
    'domain': 2000,
}

# 'LDAP', 'CORBA'
auth_method = 'CORBA'
LDAP_server = ''
LDAP_scope = ''

# gettext
gettext_domain = 'adif'
localepath = locale_dir
# lang = 'cs_CZ'
lang = 'en_US'

js_calendar_date_format = 'D.M.YYYY'
# Date format for edit fields
js_calendar_date_format_edit = 'YYYY-MM-DD'

# Javascript links to set date "new + X months" for administrative domain blocking and delete & blacklist forms:
blocking_link_add_month_count = 4
blacklisting_link_add_month_count = 1

cherrycfg = {
    'global': {
        'server.socket_port': 18456,
        'server.socket_host': "0.0.0.0",
        'server.thread_pool': 10,
        'server.environment': 'production',
        'tools.decode.on': True,
        'tools.decode.encoding': 'utf-8',
        'tools.encode.on': True,
        'tools.encode.encoding': 'utf-8',
        'tools.sessions.on': True,
        'tools.sessions.storage_type': 'file',
        'tools.sessions.storage_path': sessions_dir,
        'tools.sessions.timeout': 60,  # in minutes
        'server.log_to_screen': False,
        'server.log_file': log_dir + 'fred-webadmin.log',
    },
    '/': {'tools.staticdir.root': www_dir},
    '/css': {'tools.staticdir.on': True,
             'tools.staticdir.dir': 'css'},
    '/js': {'tools.staticdir.on': True,
            'tools.staticdir.dir': 'js'},
    '/img': {'tools.staticdir.on': True,
             'tools.staticdir.dir': 'img'},
    '/favicon.ico': {'tools.staticfile.on': True,
                     'tools.staticfile.filename': www_dir + 'img/favicon.png'}
}

properties_file = '/etc/fred/webadmin_logger_property_names.txt'
